jest.mock("../../services/smsAPI");

import {
  render,
  cleanup,
  screen,
  fireEvent,
  waitFor,
} from "@testing-library/react";
import { SMSProvider, useSMSContext } from "./SMSContext";
import { StatusProvider, useStatusContext } from "./StatusContext";

const checkBaseResults = (error, busy) => {
  expect(screen.getByTestId("error").innerHTML).toEqual(error);
  expect(screen.getByTestId("busy").innerHTML).toEqual(busy);
}

describe("SMSContext", () => {
  describe("sendSMS", () => {
    beforeEach(async () => {
      const TestComp = () => {
        const {busy, sendSMS} = useSMSContext();
        const {message, setMessage} = useStatusContext();
        const send = async (data) => {
          try {
            await
              sendSMS(data);
          } catch (e) {
            setMessage(e.message);
          }
        }

        return (
          <>
            <div data-testid="error">{message}</div>
            <div data-testid="busy">{busy.toString()}</div>
            <button
              data-testid="sendSMSNull"
              onClick={() => send(null)}
            />
            <button
              data-testid="sendSMSNoICCID"
              onClick={() => send({messageText: "test"})}
            />
            <button
              data-testid="sendSMSNoMessage"
              onClick={() => send({ICCID: "test"})}
            />
            <button
              data-testid="sendSMS"
              onClick={() => send({messageText: "test", ICCID: "test"})}
            />
          </>
        );
      };

      render(
        <StatusProvider>
          <SMSProvider>
            <TestComp/>
          </SMSProvider>
        </StatusProvider>
      );
    });

    afterEach(cleanup);

    it("initial state", () => {
      checkBaseResults("", "false");
    });

    it("should return an error if no data is passed", async () => {
      fireEvent.click(screen.getByTestId("sendSMSNull"));
      await waitFor(() => checkBaseResults("No SMS data provided", "false"));
    });

    it("should return an error if no ICCID is passed", async () => {
      fireEvent.click(screen.getByTestId("sendSMSNoICCID"));
      await waitFor(() => checkBaseResults("ICCID is required", "false"));
    });

    it("should return an error if no message is passed", async () => {
      fireEvent.click(screen.getByTestId("sendSMSNoMessage"));
      await waitFor(() => checkBaseResults("message is required", "false"));
    });

    it("should work as expected", async () => {
      fireEvent.click(screen.getByTestId("sendSMS"));
      await waitFor(() => checkBaseResults("", "true"));
    });
  });
});